Loading...
Searching...
No Matches
icu::Formattable Class Reference

Formattable objects can be passed to the Format class or its subclasses for formatting. More...

`#include <fmtable.h>`

Inheritance diagram for icu::Formattable:

## Public Types

enum | ISDATE { kIsDate }
| This enum is only used to let callers distinguish between the Formattable(UDate) constructor and the Formattable(double) constructor; the compiler cannot distinguish the signatures, since UDate is currently typedefed to be either double or long. More...
enum | Type { kDate , kDouble , kLong , kString , kArray , kInt64 , kObject }
| Selector for flavor of data type contained within a Formattable object. More...

## Public Member Functions

| Formattable ()
| Default constructor.
| Formattable (UDate d, ISDATE flag)
| Creates a Formattable object with a UDate instance.
| Formattable (double d)
| Creates a Formattable object with a double number.
| Formattable (int32_t l)
| Creates a Formattable object with a long number.
| Formattable (int64_t ll)
| Creates a Formattable object with an int64_t number.
| Formattable (const char *strToCopy)
| Creates a Formattable object with a char string pointer.
| Formattable (StringPiece number, UErrorCode &status)
| Creates a Formattable object of an appropriate numeric type from a a decimal number in string form.
| Formattable (const UnicodeString &strToCopy)
| Creates a Formattable object with a UnicodeString object to copy from.
| Formattable (UnicodeString *strToAdopt)
| Creates a Formattable object with a UnicodeString object to adopt from.
| Formattable (const Formattable *arrayToCopy, int32_t count)
| Creates a Formattable object with an array of Formattable objects.
| Formattable (UObject *objectToAdopt)
| Creates a Formattable object that adopts the given UObject.
| Formattable (const Formattable &)
| Copy constructor.
Formattable & | operator= (const Formattable &rhs)
| Assignment operator.
bool | operator== (const Formattable &other) const
| Equality comparison.
bool | operator!= (const Formattable &other) const
| Equality operator.
virtual | ~Formattable ()
| Destructor.
Formattable * | clone () const
| Clone this object.
Type | getType () const
| Gets the data type of this Formattable object.
UBool | isNumeric () const
| Returns true if the data type of this Formattable object is kDouble, kLong, or kInt64.
double | getDouble () const
| Gets the double value of this object.
double | getDouble (UErrorCode &status) const
| Gets the double value of this object.
int32_t | getLong () const
| Gets the long value of this object.
int32_t | getLong (UErrorCode &status) const
| Gets the long value of this object.
int64_t | getInt64 () const
| Gets the int64 value of this object.
int64_t | getInt64 (UErrorCode &status) const
| Gets the int64 value of this object.
UDate | getDate () const
| Gets the Date value of this object.
UDate | getDate (UErrorCode &status) const
| Gets the Date value of this object.
UnicodeString & | getString (UnicodeString &result) const
| Gets the string value of this object.
UnicodeString & | getString (UnicodeString &result, UErrorCode &status) const
| Gets the string value of this object.
const UnicodeString & | getString () const
| Gets a const reference to the string value of this object.
const UnicodeString & | getString (UErrorCode &status) const
| Gets a const reference to the string value of this object.
UnicodeString & | getString ()
| Gets a reference to the string value of this object.
UnicodeString & | getString (UErrorCode &status)
| Gets a reference to the string value of this object.
const Formattable * | getArray (int32_t &count) const
| Gets the array value and count of this object.
const Formattable * | getArray (int32_t &count, UErrorCode &status) const
| Gets the array value and count of this object.
Formattable & | operator[] (int32_t index)
| Accesses the specified element in the array value of this Formattable object.
const UObject * | getObject () const
| Returns a pointer to the UObject contained within this formattable, or nullptr if this object does not contain a UObject.
StringPiece | getDecimalNumber (UErrorCode &status)
| Returns a numeric string representation of the number contained within this formattable, or nullptr if this object does not contain numeric type.
void | setDouble (double d)
| Sets the double value of this object and changes the type to kDouble.
void | setLong (int32_t l)
| Sets the long value of this object and changes the type to kLong.
void | setInt64 (int64_t ll)
| Sets the int64 value of this object and changes the type to kInt64.
void | setDate (UDate d)
| Sets the Date value of this object and changes the type to kDate.
void | setString (const UnicodeString &stringToCopy)
| Sets the string value of this object and changes the type to kString.
void | setArray (const Formattable *array, int32_t count)
| Sets the array value and count of this object and changes the type to kArray.
void | adoptString (UnicodeString *stringToAdopt)
| Sets and adopts the string value and count of this object and changes the type to kArray.
void | adoptArray (Formattable *array, int32_t count)
| Sets and adopts the array value and count of this object and changes the type to kArray.
void | adoptObject (UObject *objectToAdopt)
| Sets and adopts the UObject value of this object and changes the type to kObject.
void | setDecimalNumber (StringPiece numberString, UErrorCode &status)
| Sets the numeric value from a decimal number string, and changes the type to to a numeric type appropriate for the number.
virtual UClassID | getDynamicClassID () const override
| ICU "poor man's RTTI", returns a UClassID for the actual class.
UFormattable * | toUFormattable ()
| Convert this object pointer to a UFormattable.
const UFormattable * | toUFormattable () const
| Convert this object pointer to a UFormattable.
int32_t | getLong (UErrorCode *status) const
| Deprecated variant of getLong(UErrorCode&).
number::impl::DecimalQuantity * | getDecimalQuantity () const
| Internal function, do not use.
void | populateDecimalQuantity (number::impl::DecimalQuantity &output, UErrorCode &status) const
| Export the value of this Formattable to a DecimalQuantity.
void | adoptDecimalQuantity (number::impl::DecimalQuantity *dq)
| Adopt, and set value from, a DecimalQuantity Internal Function, do not use.
FixedString * | internalGetFixedString (UErrorCode &status)
| Internal function to return the FixedString pointer.
Public Member Functions inherited from icu::UObject
virtual | ~UObject ()
| Destructor.

## Static Public Member Functions

static UClassID | getStaticClassID ()
| ICU "poor man's RTTI", returns a UClassID for this class.
static Formattable * | fromUFormattable (UFormattable *fmt)
| Convert the UFormattable to a Formattable.
static const Formattable * | fromUFormattable (const UFormattable *fmt)
| Convert the const UFormattable to a const Formattable.

## Detailed Description

Formattable objects can be passed to the Format class or its subclasses for formatting.

Formattable is a thin wrapper class which interconverts between the primitive numeric types (double, long, etc.) as well as UDate and UnicodeString.

Internally, a Formattable object is a union of primitive types. As such, it can only store one flavor of data at a time. To determine what flavor of data it contains, use the getType method.

As of ICU 3.0, Formattable may also wrap a UObject pointer, which it owns. This allows an instance of any ICU class to be encapsulated in a Formattable. For legacy reasons and for efficiency, primitive numeric types are still stored directly within a Formattable.

The Formattable class is not suitable for subclassing.

See UFormattable for a C wrapper.

Definition at line 63 of file fmtable.h.

## Member Enumeration Documentation

## ISDATE

enum icu::Formattable::ISDATE

This enum is only used to let callers distinguish between the Formattable(UDate) constructor and the Formattable(double) constructor; the compiler cannot distinguish the signatures, since UDate is currently typedefed to be either double or long.

If UDate is changed later to be a bonafide class or struct, then we no longer need this enum.

Stable
  ICU 2.4

Definition at line 74 of file fmtable.h.

## Type

enum icu::Formattable::Type

Selector for flavor of data type contained within a Formattable object.

Formattable is a union of several different types, and at any time contains exactly one type.

Stable
  ICU 2.4

Enumerator

kDate

Selector indicating a UDate value.

Use getDate to retrieve the value.

Stable
  ICU 2.4

kDouble

Selector indicating a double value.

Use getDouble to retrieve the value.

Stable
  ICU 2.4

kLong

Selector indicating a 32-bit integer value.

Use getLong to retrieve the value.

Stable
  ICU 2.4

kString

Selector indicating a UnicodeString value.

Use getString to retrieve the value.

Stable
  ICU 2.4

kArray

Selector indicating an array of Formattables.

Use getArray to retrieve the value.

Stable
  ICU 2.4

kInt64

Selector indicating a 64-bit integer value.

Use getInt64 to retrieve the value.

Stable
  ICU 2.8

kObject

Selector indicating a UObject value.

Use getObject to retrieve the value.

Stable
  ICU 3.0

Definition at line 220 of file fmtable.h.

## Constructor & Destructor Documentation

## Formattable() [1/12]

icu::Formattable::Formattable | ( |  | ) |

Default constructor.

Stable
  ICU 2.4

Referenced by adoptArray(), clone(), Formattable(), Formattable(), fromUFormattable(), fromUFormattable(), getArray(), getArray(), getStaticClassID(), internalGetFixedString(), operator!=(), operator=(), operator==(), operator[](), and setArray().

## Formattable() [2/12]

icu::Formattable::Formattable | ( | UDate | d,
|  | ISDATE | flag )

Creates a Formattable object with a UDate instance.

Parameters

  d | the UDate instance.
  flag | the flag to indicate this is a date. Always set it to kIsDate

Stable
  ICU 2.0

## Formattable() [3/12]

icu::Formattable::Formattable | ( | double | d | ) |

Creates a Formattable object with a double number.

Parameters

  d | the double number.

Stable
  ICU 2.0

## Formattable() [4/12]

icu::Formattable::Formattable | ( | int32_t | l | ) |

Creates a Formattable object with a long number.

Parameters

  l | the long number.

Stable
  ICU 2.0

## Formattable() [5/12]

icu::Formattable::Formattable | ( | int64_t | ll | ) |

Creates a Formattable object with an int64_t number.

Parameters

  ll | the int64_t number.

Stable
  ICU 2.8

## Formattable() [6/12]

icu::Formattable::Formattable | ( | const char * | strToCopy | ) |

Creates a Formattable object with a char string pointer.

Assumes that the char string is null terminated.

Parameters

  strToCopy | the char string.

Stable
  ICU 2.0

## Formattable() [7/12]

icu::Formattable::Formattable | ( | StringPiece | number,
|  | UErrorCode & | status )

Creates a Formattable object of an appropriate numeric type from a a decimal number in string form.

The Formattable will retain the full precision of the input in decimal format, even when it exceeds what can be represented by a double or int64_t.

Parameters

  number | the unformatted (not localized) string representation of the Decimal number.
  status | the error code. Possible errors include U_INVALID_FORMAT_ERROR if the format of the string does not conform to that of a decimal number.

Stable
  ICU 4.4

## Formattable() [8/12]

icu::Formattable::Formattable | ( | const UnicodeString & | strToCopy | ) |

Creates a Formattable object with a UnicodeString object to copy from.

Parameters

  strToCopy | the UnicodeString string.

Stable
  ICU 2.0

## Formattable() [9/12]

icu::Formattable::Formattable | ( | UnicodeString * | strToAdopt | ) |

Creates a Formattable object with a UnicodeString object to adopt from.

Parameters

  strToAdopt | the UnicodeString string.

Stable
  ICU 2.0

## Formattable() [10/12]

icu::Formattable::Formattable | ( | const Formattable * | arrayToCopy,
|  | int32_t | count )

Creates a Formattable object with an array of Formattable objects.

Parameters

  arrayToCopy | the Formattable object array.
  count | the array count.

Stable
  ICU 2.0

References Formattable().

## Formattable() [11/12]

icu::Formattable::Formattable | ( | UObject * | objectToAdopt | ) |

Creates a Formattable object that adopts the given UObject.

Parameters

  objectToAdopt | the UObject to set this object to

Stable
  ICU 3.0

## Formattable() [12/12]

icu::Formattable::Formattable | ( | const Formattable & |  | ) |

Copy constructor.

Stable
  ICU 2.0

References Formattable().

## ~Formattable()

virtual icu::Formattable::~Formattable | ( |  | ) |

virtual

Destructor.

Stable
  ICU 2.0

## Member Function Documentation

## adoptArray()

void icu::Formattable::adoptArray | ( | Formattable * | array,
|  | int32_t | count )

Sets and adopts the array value and count of this object and changes the type to kArray.

Stable
  ICU 2.0

References Formattable().

## adoptDecimalQuantity()

void icu::Formattable::adoptDecimalQuantity | ( | number::impl::DecimalQuantity * | dq | ) |

Adopt, and set value from, a DecimalQuantity Internal Function, do not use.

Parameters

  dq | the DecimalQuantity to be adopted

Internal
  Do not use. This API is for internal use only.

## adoptObject()

void icu::Formattable::adoptObject | ( | UObject * | objectToAdopt | ) |

Sets and adopts the UObject value of this object and changes the type to kObject.

After this call, the caller must not delete the given object.

Parameters

  objectToAdopt | the UObject value to be adopted

Stable
  ICU 3.0

## adoptString()

void icu::Formattable::adoptString | ( | UnicodeString * | stringToAdopt | ) |

Sets and adopts the string value and count of this object and changes the type to kArray.

Parameters

  stringToAdopt | the new string value to be adopted.

Stable
  ICU 2.0

## clone()

Formattable * icu::Formattable::clone | ( |  | ) | const

Clone this object.

Clones can be used concurrently in multiple threads. If an error occurs, then nullptr is returned. The caller must delete the clone.

Returns
  a clone of this object

See also
  getDynamicClassID

Stable
  ICU 2.8

References Formattable().

## fromUFormattable() [1/2]

const Formattable * icu::Formattable::fromUFormattable | ( | const UFormattable * | fmt | ) |

inline static

Convert the const UFormattable to a const Formattable.

Internally, this is a reinterpret_cast.

Parameters

  fmt | a valid UFormattable

Returns
  the UFormattable as a Formattable object pointer. This is an alias to the original UFormattable, and so is only valid while the original argument remains in scope.

Stable
  ICU 52

Definition at line 747 of file fmtable.h.

References Formattable(), and fromUFormattable().

## fromUFormattable() [2/2]

Formattable * icu::Formattable::fromUFormattable | ( | UFormattable * | fmt | ) |

inline static

Convert the UFormattable to a Formattable.

Internally, this is a reinterpret_cast.

Parameters

  fmt | a valid UFormattable

Returns
  the UFormattable as a Formattable object pointer. This is an alias to the original UFormattable, and so is only valid while the original argument remains in scope.

Stable
  ICU 52

Definition at line 743 of file fmtable.h.

References Formattable(), and fromUFormattable().

Referenced by fromUFormattable(), fromUFormattable(), and getStaticClassID().

## getArray() [1/2]

const Formattable * icu::Formattable::getArray | ( | int32_t & | count | ) | const

inline

Gets the array value and count of this object.

If this object is not of type kArray then the result is undefined.

Parameters

  count | fill-in with the count of this object.

Returns
  the array value of this object.

Stable
  ICU 2.0

Definition at line 442 of file fmtable.h.

References Formattable().

## getArray() [2/2]

const Formattable * icu::Formattable::getArray | ( | int32_t & | count,
|  | UErrorCode & | status ) const

Gets the array value and count of this object.

If the type is not an array, status is set to U_INVALID_FORMAT_ERROR, count is set to 0, and the result is nullptr.

Parameters

  count | fill-in with the count of this object.
  status | the error code.

Returns
  the array value of this object.

Stable
  ICU 3.0

References Formattable().

## getDate() [1/2]

UDate icu::Formattable::getDate | ( |  | ) | const

inline

Gets the Date value of this object.

If this object is not of type kDate then the result is undefined.

Returns
  the Date value of this object.

Stable
  ICU 2.0

Definition at line 365 of file fmtable.h.

Referenced by getDate().

## getDate() [2/2]

UDate icu::Formattable::getDate | ( | UErrorCode & | status | ) | const

inline

Gets the Date value of this object.

If the type is not a date, status is set to U_INVALID_FORMAT_ERROR and the return value is undefined.

Parameters

  status | the error code.

Returns
  the Date value of this object.

Stable
  ICU 3.0

Definition at line 711 of file fmtable.h.

References getDate(), kDate, U_INVALID_FORMAT_ERROR, and U_SUCCESS.

## getDecimalNumber()

StringPiece icu::Formattable::getDecimalNumber | ( | UErrorCode & | status | ) |

Returns a numeric string representation of the number contained within this formattable, or nullptr if this object does not contain numeric type.

For values obtained by parsing, the returned decimal number retains the full precision and range of the original input, unconstrained by the limits of a double floating point or a 64 bit int.

This function is not thread safe, and therefore is not declared const, even though it is logically const.

Possible errors include U_MEMORY_ALLOCATION_ERROR, and U_INVALID_STATE if the formattable object has not been set to a numeric type.

Parameters

  status | the error code.

Returns
  the unformatted string representation of a number.

Stable
  ICU 4.4

## getDecimalQuantity()

number::impl::DecimalQuantity * icu::Formattable::getDecimalQuantity | ( |  | ) | const

inline

Internal function, do not use.

TODO: figure out how to make this be non-public. NumberFormat::format(Formattable, ... needs to get at the DecimalQuantity, if it exists, for big decimal formatting.

Internal
  Do not use. This API is for internal use only.

Definition at line 651 of file fmtable.h.

## getDouble() [1/2]

double icu::Formattable::getDouble | ( |  | ) | const

inline

Gets the double value of this object.

If this object is not of type kDouble then the result is undefined.

Returns
  the double value of this object.

Stable
  ICU 2.0

Definition at line 292 of file fmtable.h.

## getDouble() [2/2]

double icu::Formattable::getDouble | ( | UErrorCode & | status | ) | const

Gets the double value of this object.

If this object is of type long, int64 or Decimal Number then a conversion is performed, with possible loss of precision. If the type is kObject and the object is a Measure, then the result of getNumber().getDouble(status) is returned. If this object is neither a numeric type nor a Measure, then 0 is returned and the status is set to U_INVALID_FORMAT_ERROR.

Parameters

  status | the error code

Returns
  the double value of this object.

Stable
  ICU 3.0

## getDynamicClassID()

virtual UClassID icu::Formattable::getDynamicClassID | ( |  | ) | const

override virtual

ICU "poor man's RTTI", returns a UClassID for the actual class.

Stable
  ICU 2.2

Reimplemented from icu::UObject.

## getInt64() [1/2]

int64_t icu::Formattable::getInt64 | ( |  | ) | const

inline

Gets the int64 value of this object.

If this object is not of type kInt64 then the result is undefined.

Returns
  the int64 value of this object.

Stable
  ICU 2.8

Definition at line 340 of file fmtable.h.

## getInt64() [2/2]

int64_t icu::Formattable::getInt64 | ( | UErrorCode & | status | ) | const

Gets the int64 value of this object.

If this object is of a numeric type and the magnitude is too large to fit in an int64, then the maximum or minimum int64 value, as appropriate, is returned and the status is set to U_INVALID_FORMAT_ERROR. If the magnitude fits in an int64, then a casting conversion is performed, with truncation of any fractional part. If the type is kObject and the object is a Measure, then the result of getNumber().getDouble(status) is returned. If this object is neither a numeric type nor a Measure, then 0 is returned and the status is set to U_INVALID_FORMAT_ERROR.

Parameters

  status | the error code

Returns
  the int64 value of this object.

Stable
  ICU 3.0

## getLong() [1/3]

int32_t icu::Formattable::getLong | ( |  | ) | const

inline

Gets the long value of this object.

If this object is not of type kLong then the result is undefined.

Returns
  the long value of this object.

Stable
  ICU 2.0

Definition at line 314 of file fmtable.h.

Referenced by getLong(), and getStaticClassID().

## getLong() [2/3]

int32_t icu::Formattable::getLong | ( | UErrorCode & | status | ) | const

Gets the long value of this object.

If the magnitude is too large to fit in a long, then the maximum or minimum long value, as appropriate, is returned and the status is set to U_INVALID_FORMAT_ERROR. If this object is of type kInt64 and it fits within a long, then no precision is lost. If it is of type kDouble, then a conversion is performed, with truncation of any fractional part. If the type is kObject and the object is a Measure, then the result of getNumber().getLong(status) is returned. If this object is neither a numeric type nor a Measure, then 0 is returned and the status is set to U_INVALID_FORMAT_ERROR.

Parameters

  status | the error code

Returns
  the long value of this object.

Stable
  ICU 3.0

## getLong() [3/3]

int32_t icu::Formattable::getLong | ( | UErrorCode * | status | ) | const

inline

Deprecated variant of getLong(UErrorCode&).

Parameters

  status | the error code

Returns
  the long value of this object.

Deprecated
  ICU 3.0 use getLong(UErrorCode&) instead

Definition at line 730 of file fmtable.h.

References getLong().

## getObject()

const UObject * icu::Formattable::getObject | ( |  | ) | const

Returns a pointer to the UObject contained within this formattable, or nullptr if this object does not contain a UObject.

Returns
  a UObject pointer, or nullptr

Stable
  ICU 3.0

## getStaticClassID()

UClassID icu::Formattable::getStaticClassID | ( |  | ) |

static

ICU "poor man's RTTI", returns a UClassID for this class.

Stable
  ICU 2.2

References Formattable(), fromUFormattable(), getLong(), and toUFormattable().

## getString() [1/6]

UnicodeString & icu::Formattable::getString | ( |  | ) |

inline

Gets a reference to the string value of this object.

If this object is not of type kString then the result is undefined.

Returns
  a reference to the string value of this object.

Stable
  ICU 2.0

Definition at line 725 of file fmtable.h.

References getString().

## getString() [2/6]

const UnicodeString & icu::Formattable::getString | ( |  | ) | const

inline

Gets a const reference to the string value of this object.

If this object is not of type kString then the result is undefined.

Returns
  a const reference to the string value of this object.

Stable
  ICU 2.0

Definition at line 721 of file fmtable.h.

References getString().

## getString() [3/6]

UnicodeString & icu::Formattable::getString | ( | UErrorCode & | status | ) |

Gets a reference to the string value of this object.

If the type is not a string, status is set to U_INVALID_FORMAT_ERROR and the result is a bogus string.

Parameters

  status | the error code.

Returns
  a reference to the string value of this object.

Stable
  ICU 3.0

## getString() [4/6]

const UnicodeString & icu::Formattable::getString | ( | UErrorCode & | status | ) | const

Gets a const reference to the string value of this object.

If the type is not a string, status is set to U_INVALID_FORMAT_ERROR and the result is a bogus string.

Parameters

  status | the error code.

Returns
  a const reference to the string value of this object.

Stable
  ICU 3.0

References getString().

## getString() [5/6]

UnicodeString & icu::Formattable::getString | ( | UnicodeString & | result | ) | const

inline

Gets the string value of this object.

If this object is not of type kString then the result is undefined.

Parameters

  result | Output param to receive the Date value of this object.

Returns
  A reference to 'result'.

Stable
  ICU 2.0

Definition at line 384 of file fmtable.h.

Referenced by getString(), getString(), getString(), and getString().

## getString() [6/6]

UnicodeString & icu::Formattable::getString | ( | UnicodeString & | result,
|  | UErrorCode & | status ) const

Gets the string value of this object.

If the type is not a string, status is set to U_INVALID_FORMAT_ERROR and a bogus string is returned.

Parameters

  result | Output param to receive the Date value of this object.
  status | the error code.

Returns
  A reference to 'result'.

Stable
  ICU 3.0

References getString().

## getType()

Type icu::Formattable::getType | ( |  | ) | const

Gets the data type of this Formattable object.

Returns
  the data type of this Formattable object.

Stable
  ICU 2.0

## internalGetFixedString()

FixedString * icu::Formattable::internalGetFixedString | ( | UErrorCode & | status | ) |

Internal function to return the FixedString pointer.

Parameters

  status | error code

Returns
  pointer to the FixedString - may become invalid if the object is modified

Internal
  Do not use. This API is for internal use only.

References Formattable().

## isNumeric()

UBool icu::Formattable::isNumeric | ( |  | ) | const

Returns true if the data type of this Formattable object is kDouble, kLong, or kInt64.

Returns
  true if this is a pure numeric object

Stable
  ICU 3.0

## operator!=()

bool icu::Formattable::operator!= | ( | const Formattable & | other | ) | const

inline

Equality operator.

Parameters

  other | the object to be compared with.

Returns
  true if other are unequal to this, false otherwise.

Stable
  ICU 2.0

Definition at line 192 of file fmtable.h.

References Formattable(), and icu::operator==().

## operator=()

Formattable & icu::Formattable::operator= | ( | const Formattable & | rhs | ) |

Assignment operator.

Parameters

  rhs | The Formattable object to copy into this object.

Stable
  ICU 2.0

References Formattable().

## operator==()

bool icu::Formattable::operator== | ( | const Formattable & | other | ) | const

Equality comparison.

Parameters

  other | the object to be compared with.

Returns
  true if other are equal to this, false otherwise.

Stable
  ICU 2.0

References Formattable().

## operator[]()

Formattable & icu::Formattable::operator[] | ( | int32_t | index | ) |

inline

Accesses the specified element in the array value of this Formattable object.

If this object is not of type kArray then the result is undefined.

Parameters

  index | the specified index.

Returns
  the accessed element in the array.

Stable
  ICU 2.0

Definition at line 464 of file fmtable.h.

References Formattable().

## populateDecimalQuantity()

void icu::Formattable::populateDecimalQuantity | ( | number::impl::DecimalQuantity & | output,
|  | UErrorCode & | status ) const

Export the value of this Formattable to a DecimalQuantity.

Internal
  Do not use. This API is for internal use only.

## setArray()

void icu::Formattable::setArray | ( | const Formattable * | array,
|  | int32_t | count )

Sets the array value and count of this object and changes the type to kArray.

Parameters

  array | the array value.
  count | the number of array elements to be copied.

Stable
  ICU 2.0

References Formattable().

## setDate()

void icu::Formattable::setDate | ( | UDate | d | ) |

Sets the Date value of this object and changes the type to kDate.

Parameters

  d | the new Date value to be set.

Stable
  ICU 2.0

## setDecimalNumber()

void icu::Formattable::setDecimalNumber | ( | StringPiece | numberString,
|  | UErrorCode & | status )

Sets the numeric value from a decimal number string, and changes the type to to a numeric type appropriate for the number.

The syntax of the number is a "numeric string" as defined in the Decimal Arithmetic Specification, available at http://speleotrove.com/decimal The full precision and range of the input number will be retained, even when it exceeds what can be represented by a double or an int64.

Parameters

  numberString | a string representation of the unformatted decimal number.
  status | the error code. Set to U_INVALID_FORMAT_ERROR if the incoming string is not a valid decimal number.

Stable
  ICU 4.4

## setDouble()

void icu::Formattable::setDouble | ( | double | d | ) |

Sets the double value of this object and changes the type to kDouble.

Parameters

  d | the new double value to be set.

Stable
  ICU 2.0

## setInt64()

void icu::Formattable::setInt64 | ( | int64_t | ll | ) |

Sets the int64 value of this object and changes the type to kInt64.

Parameters

  ll | the new int64 value to be set.

Stable
  ICU 2.8

## setLong()

void icu::Formattable::setLong | ( | int32_t | l | ) |

Sets the long value of this object and changes the type to kLong.

Parameters

  l | the new long value to be set.

Stable
  ICU 2.0

## setString()

void icu::Formattable::setString | ( | const UnicodeString & | stringToCopy | ) |

Sets the string value of this object and changes the type to kString.

Parameters

  stringToCopy | the new string value to be set.

Stable
  ICU 2.0

## toUFormattable() [1/2]

UFormattable * icu::Formattable::toUFormattable | ( |  | ) |

inline

Convert this object pointer to a UFormattable.

Returns
  this object as a UFormattable pointer. This is an alias to this object, and so is only valid while this object remains in scope.

Stable
  ICU 52

Definition at line 735 of file fmtable.h.

References toUFormattable().

Referenced by getStaticClassID(), toUFormattable(), and toUFormattable().

## toUFormattable() [2/2]

const UFormattable * icu::Formattable::toUFormattable | ( |  | ) | const

inline

Convert this object pointer to a UFormattable.

Returns
  this object as a UFormattable pointer. This is an alias to this object, and so is only valid while this object remains in scope.

Stable
  ICU 52

Definition at line 739 of file fmtable.h.

References toUFormattable().

## Field Documentation

## fArray

Formattable* icu::Formattable::fArray

Definition at line 698 of file fmtable.h.

## fCount

int32_t icu::Formattable::fCount

Definition at line 699 of file fmtable.h.

## fDate

UDate icu::Formattable::fDate

Definition at line 696 of file fmtable.h.

## fDouble

double icu::Formattable::fDouble

Definition at line 694 of file fmtable.h.

## fInt64

int64_t icu::Formattable::fInt64

Definition at line 695 of file fmtable.h.

## fObject

UObject* icu::Formattable::fObject

Definition at line 692 of file fmtable.h.

## fString

UnicodeString* icu::Formattable::fString

Definition at line 693 of file fmtable.h.

The documentation for this class was generated from the following file:

- i18n/unicode/fmtable.h